package com.wissamfawaz;

import java.io.IOException;
import java.io.ObjectOutputStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.NoSuchElementException;
import java.util.Scanner;

public class CreateSerFile {
	private ObjectOutputStream output;

	public void openFile() {
		try {
			output = new ObjectOutputStream(Files.newOutputStream(Paths.get("records.ser")));
		} catch (IOException e) {
			System.err.println("Error opening the file. Terminating.");
			System.exit(1);
		}

	}

	public void addRecords() {
		Scanner scan = new Scanner(System.in);
		System.out.printf("%s%n", "Enter account records followed by EOF indicator.");
		System.out.printf("%s%n", "Enter ID, first, last names, and balance.");

		while (scan.hasNext()) {
			try {
				output.writeObject(new Account(scan.nextInt(), scan.next(), scan.next(), scan.nextDouble()));
			} catch (NoSuchElementException e) {
				System.err.println("Invalid input type. Try again.");
				scan.nextLine();
			} catch (IOException e) {
				System.err.println("Error writing object to file. Terminating.");
				break;
			}
			System.out.printf("%s%n", "Enter ID, first, last names, and balance.");
		}

		scan.close();
	}

	public void closeFile() {
		if (output != null)
			try {
				output.close();
			} catch (IOException e) {
				System.err.println("Error closing the file.");
				System.exit(1);
			}
	}

}
